using System;

namespace Dobro_Pravougaonici
{
    class Program
    {
        static void Main(string[] args)
        {
            int[,] m;
            //Temp
            string unos = Console.ReadLine();
            int ve = Convert.ToInt32(unos.Substring(0, unos.IndexOf(' ')));
            m = new int[ve, ve];
            //Koliko vrsta jabuka ima;
            int k = Convert.ToInt32(unos.Substring(unos.IndexOf(' ')));
            //Koliko kojeg drveta ima
            int[] ukupno = new int[k + 1];
            //Resenje
            int resenje = 0;
            for (int i = 0; i < ve; i++)
            {
                //Promeniti da bude jednak ulazu u consolu
                string t = Console.ReadLine();
                for (int j = 0; j < ve; j++)
                {
                    if (t.Contains(" "))
                    {
                        m[i, j] = Convert.ToInt32(t.Substring(0, t.IndexOf(' ')));
                    }
                    else
                    {
                        m[i, j] = Convert.ToInt32(t.Substring(0));
                    }
                    t = t.Substring(t.IndexOf(' ') + 1);
                    //Povecati ukupnu kolicinu tog drveta
                    ukupno[m[i, j]]++;
                }
            }
            for (int temp = 0; temp < k; temp++)
            {
                int px = 0, py = 0, kx = 0, ky = 0;
                //Da li je detektovao prvi
                bool detektovao = false;
                for (int i = 0; i < ve; i++)
                    for (int j = 0; j < ve; j++)
                    {
                        if (m[i, j] == temp)
                        {
                            if (detektovao == false)
                            {
                                px = i;
                                py = j;
                                detektovao = true;
                            }
                            kx = i;
                            ky = j;
                        }
                    }
                int sirina = kx - px + 1;
                int duzina = ky - py + 1;
                int povrsina = sirina * duzina;
                if (povrsina == ukupno[temp])
                {
                    resenje++;
                }
            }
            Console.WriteLine(resenje);
            //Console.ReadKey();
        }
    }
}